/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - 11 December, 2003.
   -
   - The Initial Developer of the Original Code is HJ van Rantwijk.
   - Portions created by HJ van Rantwijk are Copyright (C) 2003-2007
   - HJ van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -	Michael Vincent van Rantwijk <mv_van_rantwijk@yahoo.com>
   -
   - this can be used by adding:
     <vbox id="appcontent" onclick="multiZillaAntiCMenuHijack.click(event);"/>
     to [your overlay name].xul
*/

////////////////////////////////////////////////////////////////////////////////
// JavaScript 'class' to preserve YOUR context menu :-)
////////////////////////////////////////////////////////////////////////////////
var multiZillaAntiCMenuHijack = 
{
  aBundle : null,

  init: function()
  {
    aBundle = srGetStrBundle("chrome://multiviews/locale/tabbrowser.properties");
  },

  click: function(aEvent)
  {
    if (aEvent.button == 2 ) {
      var cmCheckPrefValue = 0;

      try {
        cmCheckPrefValue = pref.getIntPref("multizilla.document.context-menu.behavior");
      }
      catch(ex) {
        pref.setIntPref("multizilla.document.context-menu.behavior", cmCheckPrefValue);
      }
      if (cmCheckPrefValue > 0) {
        var documentWrapper = Components.lookupMethod(aEvent.originalTarget, "ownerDocument").call(aEvent.originalTarget);
        this.contextMenuCheck(documentWrapper, cmCheckPrefValue, aEvent);
      }
    }
  },

  contextMenuCheck: function(aDocument, aAction, aEvent)
  {
    if (aDocument instanceof HTMLDocument) {
      if (aDocument.location.href.indexOf("chrome:") > -1)
        return;

      var targetElements = new Array();
      var hasModifiedContextMenu = (aAction == 2);
      var sContent = new XPCNativeWrapper(window.content, "frames").frames;

      if (aAction == 1) {
        targetElements = this.checkContextMenu(aDocument, aEvent, targetElements);

        if (targetElements.length)
          hasModifiedContextMenu = true;

        for (var i = 0; i < sContent.frames.length; i++) {
          targetElements = this.checkContextMenu(sContent.frames[i].document, aEvent, targetElements);

          if (targetElements.length) {
            hasModifiedContextMenu = true;
            break;
          }
        }
      }
      if (hasModifiedContextMenu) {
        if (aAction == 1 && !this.confirmReset())
          return;
        targetElements = (targetElements.length == 0) ? ["html", "body", "img"] : targetElements;
        this.resetOnContextMenu(aDocument, targetElements);

        for (i = 0; i < sContent.frames.length; i++) {
          this.resetOnContextMenu(sContent.frames[i].document, targetElements);
        }
      }
    }
  },

  checkContextMenu: function(aDocument, aEvent, aModifiedElementList)
  {
    const RETURN_TRUE = "return true;";
    var element = aDocument.getElementsByTagName('html')[0];

    if (element && 'oncontextmenu' in element) {
      if (element.oncontextmenu != undefined) {
        if (aModifiedElementList.indexOf("html") == -1)
          aModifiedElementList.push("html");
      }
    }
    if ('oncontextmenu' in aDocument && aDocument.oncontextmenu != undefined || 
        'onmouseup' in aDocument && aDocument.onmouseup != undefined || 
        'onmousedown' in aDocument && aDocument.onmousedown != undefined)
    {
      if (aModifiedElementList.indexOf("html") == -1)
        aModifiedElementList.push("html");
    }
    element = aDocument.getElementsByTagName('body')[0];

    if (element && element.hasAttribute('oncontextmenu')) {
      if (element.getAttribute('oncontextmenu') != RETURN_TRUE) {
        if (aModifiedElementList.indexOf("body") == -1)
          aModifiedElementList.push("body");
      }
    }
    var targetElements = ["img"];
    var clickedNodeName = aEvent.originalTarget.localName.toLowerCase();

    if (clickedNodeName != "img")
      targetElements.push(clickedNodeName);

    for (i in targetElements) {
      var targetElementName = targetElements[i];
      var elementList = aDocument.getElementsByTagName(targetElementName);

      for (var i =0; i < elementList.length; i++) {
        element = elementList[i];

        if (element && element.hasAttribute('oncontextmenu')) {
          if (element.getAttribute('oncontextmenu') != RETURN_TRUE) {
            if (aModifiedElementList.indexOf(targetElementName) == -1)
              aModifiedElementList.push(targetElementName);
            break;
          }
        }
      }
    }
    return (aModifiedElementList);
  },

  confirmReset: function()
  {
    var checkbox = {value:false};
    var dialogTitle = aBundle.GetStringFromName('mzWizard');
    var dialogText = aBundle.GetStringFromName('contextMenuCheckTitle');
    var checkboxText = aBundle.GetStringFromName('contextMenuCheckCheckbox');
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    var result = promptService.confirmEx(window, dialogTitle, dialogText, 
                                        (promptService.BUTTON_POS_0 * promptService.BUTTON_TITLE_YES) +
                                        (promptService.BUTTON_POS_1 * promptService.BUTTON_TITLE_NO),
                                         null, null, null, checkboxText, checkbox);
    if (result)
      return false;
    else if (checkbox.value)
      pref.setIntPref("multizilla.document.context-menu.behavior", 2);
    return true;
  }, 

  resetOnContextMenu: function(aDocument, aTargetElementList)
  {
    const RETURN_TRUE = "return true;";
    var element;

    for (var t = 0; t < aTargetElementList.length; t++) {
      var targetElement = aTargetElementList[t];

      if (targetElement == "html") {
        element = aDocument.getElementsByTagName(targetElement)[0];
        element.onmouseup = undefined;
        element.onmousedown = undefined;
        element.oncontextmenu = undefined;

        aDocument.onmouseup = undefined;
        aDocument.onmousedown = undefined;
        aDocument.oncontextmenu = undefined;
      }
      else { // body, img, etc
        var elementList = aDocument.getElementsByTagName(targetElement);

        for (var n = 0; n < elementList.length; n++) {
          var element = elementList[n];

          if (element && element.getAttribute('oncontextmenu') != RETURN_TRUE)
            element.setAttribute('oncontextmenu', RETURN_TRUE);
        }
      }
    }
  }
};

addEventListener("load", multiZillaAntiCMenuHijack.init, false);
