/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code in this file as it was released upon
 * April 1, 2001 and that is NOT a joke!
 *
 * The Initial Developer of the Original Code is HJ van Rantwijk.
 * all Portions created by HJ van Rantwijk are Copyright (C) 2001-2007
 * by HJ van Rantwijk. All Rights Reserved.
 *
 * Contributor(s): 
 *
 *  Huijing Zhou <hj@cip.wiwi.uni-karlsruhe.de>
 *  Raj Bhaskar <r.bhaskar@compserv.gla.ac.uk>
 *  Michael Vincent van Rantwijk <mv_van_rantwijk@yahoo.com>
*/

const G_VER             = "1.8.3.1";
const G_REVISION        = "e";
const G_MSG             = "MultiZilla v" + G_VER + G_REVISION;
const G_NAME            = "multiviews";

const G_NEED_BUILD      = 2006070100;
const G_NEED_BUILD_4MAC = 2006070100;

const G_CHROME          = "chrome";
const G_PROFILE         = "Current User"; // "Profile";

const G_DEFAULTS        = "defaults";
const G_PREFS           = "Preferences";
const G_PROGRAM         = "program";
const G_COMPONENTS      = "components";
const G_CONTENT         = "content/multiviews/";

const G_MODERN_SKIN     = "skin/modern/multiviews/";
const G_CLASSIC_SKIN    = "skin/classic/multiviews/";

const G_LOCALE             = "locale/en-US/multiviews/";
const G_MULTIZILLA_JAR     = "multiviews.jar";
const G_PREF_FILE          = "all-mz.js";

const G_UPDATENOTIFIER_SERVICE = "mzUpdateNotifier.js";
const G_CONTENTBLOCKER_SERVICE = "mzContentBlocker.js";
const G_MZWEBFEEDS_SERVICE     = "mzWebFeeds.js";
const G_MZWEBFEEDS_XPT         = "mzWebFeeds.xpt";

const G_MULTIZILLA_RDF    = "multizilla.rdf";
const G_CONTENBLOCKER_RDF = "default-filters.rdf";
const G_USERAGENTS_RDF    = "useragents.rdf";
const G_MZWEBFEEDS_RDF    = "mzWebFeeds.rdf";


const G_PROGRAM_DIR    = getFolder(G_PROGRAM);
const G_COMPONENTS_DIR = getFolder(G_COMPONENTS);
const G_DEFPREF_DIR    = getFolder(G_PROGRAM, "defaults/pref");
const G_DEFPROFILE_DIR = getFolder(G_PROGRAM, "defaults/profile");
const G_PROFILE_DIR    = getFolder(G_PROFILE);
const G_COMPREG_DAT    = getFolder(G_PROGRAM, "components/compreg.dat");
const G_XPTI_DAT       = getFolder(G_PROGRAM, "components/xpti.dat");

const COMNT_1  = "Installation of " + G_MSG;
const COMNT_2  = "MultiZilla - jar file (multiviews.jar)";
const COMNT_3  = "Version to old for this version of MultiZilla: Aborting Installation";
const COMNT_4  = "MultiZilla - default preference settings (all-mz.js)";
const COMNT_5  = "MultiZilla - RDF file (multizilla.rdf)";
const COMNT_6  = "MultiZilla - Update Notifier (mzUpdateNotifier.js)";
const COMNT_7  = "Warning: installing with self compiled version (BuildID = 0)";
const COMNT_8  = "MultiZilla - Content Blocker (mzContentBlocker.js)";
const COMNT_9  = "MultiZilla - Content Blocker (default-filters.rdf)";
const COMNT_10 = "MultiZilla - HTTP User Agents (useragents.rdf)";
const COMNT_11 = "MultiZilla - Feed Service (mzWebFeeds.js)";
const COMNT_12 = "MultiZilla - Feed Service (mzWebFeeds.xpt)";
const COMNT_13 = "MultiZilla - Feed Service (mwWebFeeds.rdf)";

// The MultiZilla installation process is 'multi-user based' by default
var G_CHROME_LOC = G_CHROME;
var G_CHROME_TYPE = DELAYED_CHROME;
var G_CHROME_DIR = getFolder(G_CHROME);
var installTypeMsg = "InstallType: multi-user installation";
// Check for prior installations in the users profile directory
var profileChromeDir = getFolder("Current User", G_CHROME); 
var profileJAR = getFolder(profileChromeDir, G_MULTIZILLA_JAR); // getFolder(G_PROFILE, G_MULTIZILLA_JAR);
var priorProfileInstall = File.exists(profileJAR);
// Check for prior installations in the program directory
var chromeJAR = getFolder(G_CHROME, G_MULTIZILLA_JAR);
var priorChromeInstall = File.exists(chromeJAR);
var priorInstallation = false; // Initialize the prior installation flag

  if (priorProfileInstall || priorChromeInstall)
    priorInstallation = true;

  if (!priorInstallation) {
    logComment("New MultiZilla installation");
    // Ask if MultiZilla should be installed in the profile directory, but only for new installations
    // Installing the same add-on, in both the profile and chrome directory, makes one big mess of it!
    if (confirm("Select OK, for a single-user installation\nor CANCEL, for a multi-user installation")) {
      installTypeMsg = "InstallType: single-user installation";
      G_CHROME_TYPE = PROFILE_CHROME; // | DELAYED_CHROME;
      G_CHROME_DIR = profileChromeDir; // getFolder(G_PROFILE);
      G_CHROME_LOC = profileChromeDir; // G_PROFILE;
    }
    else {
      installTypeMsg = "InstallType: multi-user installation";
    }
  }
  // We end-up here after locating a prior installation in the users profile directory
  // No need for a confirmation, just install MultiZilla in the profile directory
  else if (priorProfileInstall) {
    installTypeMsg = "InstallType: single-user installation";
    G_CHROME_TYPE = PROFILE_CHROME; // | DELAYED_CHROME;
    G_CHROME_DIR = profileChromeDir; // getFolder(G_PROFILE);
    G_CHROME_LOC = profileChromeDir; // G_PROFILE;
  }
  var err = initInstall(G_MSG, G_NAME, G_VER);
  var platformNode = "Unknown";
  var platformIdentifier = "Unknown";
  var abort = true;

  logComment(COMNT_1 + " in directory: " + G_CHROME_DIR);
  logComment("initInstall: " + err);
  logComment(installTypeMsg);

  if (!err)
    err = "Ok";
  logComment("Installation init : " + err);

  if ('platform' in Install) {
    var platformStr = new String(Install.platform);

    if (!platformStr.search(/.*Darwin/)) {
      platformNode = 'unix';
      platformIdentifier = 'Unix (Darwin)';
    }
    else if (!platformStr.search(/^Macintosh/)) {
      platformNode = 'mac';
      platformIdentifier = 'Macintosh';
    }
    else if (!platformStr.search(/^Win/)) {
      platformNode = 'win';
      platformIdentifier = 'Windows';
    }
    else if (!platformStr.search(/^OS\/2/)) {
      platformNode = 'win';
      platformIdentifier = 'OS/2';
    }
    else {
      platformNode = 'unix';
      platformIdentifier = 'Unix';
    }
  }
  else {
    var fOSMac = getFolder("Mac System");
    var fOSWin = getFolder("Win System");

    logComment("fOSMac: "  + fOSMac);
    logComment("fOSWin: "  + fOSWin);

    if (fOSMac != null) {
      platformNode = 'mac';
      platformIdentifier = 'Macintosh';
    }
    else if (fOSWin != null) {
      platformNode = 'win';
      platformIdentifier = 'Windows';
    }
    else {
      platformNode = 'unix';
      platformIdentifier = 'Unix';
    }
  }
  var buildIDNeeded = G_NEED_BUILD;

  if (platformIdentifier == "Macintosh")
    buildIDNeeded = G_NEED_BUILD_4MAC;
  if (buildID > buildIDNeeded)
    abort = false;

  if (abort) {
    if (buildID > 0) {
      alert("Aborting this " + COMNT_1 + 
            "\n\nYou need SeaMonkey: " + buildIDNeeded + " for the " + COMNT_1 +
            "\n\nPlease visit http://www.mozilla.org/projects/seamonkey/ and install SeaMonkey");
      logComment(COMNT_3);
      cancelInstall();
    }
    else { // No BuildID, compiled without env. variable set!
      alert("Warning: BuildID = 0\n" + 
            "This installation might fail befause of this!\n" + 
            "Please read the instructions on this page:\n\n" + 
            "http://www.mozilla.org/build/distribution.html");
      logComment(COMNT_7);
      abort = false; // allow installation anyway
    }
  }
  if (!abort) {
    /***
      * MultiZilla's 'Update Notifications' needs to be registered
      * and this doesn't seem to work for older mozilla builds.
      * We just wack the registry, to make sure it gets registered!
      */
    if (File.exists(G_COMPREG_DAT))
      File.remove(G_COMPREG_DAT);
    if (File.exists(G_XPTI_DAT))
      File.remove(G_XPTI_DAT);

    addFile(COMNT_2, G_MULTIZILLA_JAR, G_CHROME_DIR, "");
    addFile(COMNT_4, G_PREF_FILE, G_DEFPREF_DIR, "");
    addFile(COMNT_6, G_UPDATENOTIFIER_SERVICE, G_COMPONENTS_DIR, "");
    addFile(COMNT_8, G_CONTENTBLOCKER_SERVICE, G_COMPONENTS_DIR, "");
    addFile(COMNT_11, G_MZWEBFEEDS_SERVICE, G_COMPONENTS_DIR, "");
    addFile(COMNT_12, G_MZWEBFEEDS_XPT, G_COMPONENTS_DIR, "");

    if (!File.exists(getFolder(G_PROFILE, G_MULTIZILLA_RDF)))
      addFile(COMNT_5, G_MULTIZILLA_RDF, G_PROFILE_DIR, "")

    if (!File.exists(getFolder(G_PROFILE, G_USERAGENTS_RDF)))
      addFile(COMNT_10, G_USERAGENTS_RDF, G_PROFILE_DIR, "");

    if (!File.exists(getFolder(G_PROFILE, G_MZWEBFEEDS_RDF)))
      addFile(COMNT_13, G_MZWEBFEEDS_RDF, G_PROFILE_DIR, "");

    addFile(COMNT_5, G_MULTIZILLA_RDF, G_DEFPROFILE_DIR, "");
    addFile(COMNT_9, G_CONTENBLOCKER_RDF, G_PROFILE_DIR, "");

    logComment("Installation started on: " + platformIdentifier);
	registerChrome(CONTENT | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_MULTIZILLA_JAR), G_CONTENT);
    registerChrome(SKIN    | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_MULTIZILLA_JAR), G_MODERN_SKIN);
    registerChrome(SKIN    | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_MULTIZILLA_JAR), G_CLASSIC_SKIN);
    registerChrome(LOCALE  | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_MULTIZILLA_JAR), G_LOCALE);

    err = getLastError();

    if (err == SUCCESS)
      err = performInstall();
    else {
      if (err == ACCESS_DENIED)
        logComment("The user did not grant the required security privilege.");
      logComment("Detailed information can be found at: http://multizilla.mozdev.org/xpi/return-codes.html#ret-202");
      cancelInstall(err);
    }
    err = getLastError();

    if (err == SUCCESS || err == REBOOT_NEEDED) {
      var msg = G_MSG + " has been installed successfully: " + err;
      var finish = (err == SUCCESS) ? "\nPlease restart your browser (including QuickLaunch) to continue." :
                                      "\nYou might need to reboot, restart your browser (including QuickLaunch) to continue.";
      refreshPlugins();
      alert(msg + finish);
    }
  }

